{-# LANGUAGE QuasiQuotes     #-}
{-# LANGUAGE TemplateHaskell #-}

module Core.Templates ( renderIndex, renderStyle, hxVals ) where

import           Text.Blaze.Html
import           Text.Blaze.Html.Renderer.Text (renderHtml)
import           Text.Cassius                  (cassiusFile, renderCss)
import           Text.Hamlet                   (shamletFile)

import qualified Data.Text                     as T
import qualified Data.Text.Lazy                as LT

import           Prelude

renderIndex :: String -> String -> LT.Text
renderIndex link email = renderHtml ( $(shamletFile "./views/index.hamlet") )
  where
    hsUserLink = hxVals "userLink" link

renderStyle :: LT.Text
renderStyle = renderCss ( $(cassiusFile "./views/cassius/style.cassius") "/style.css" )

hxVals :: String -> String -> (String, String)
hxVals attr str = ("hx-vals", "{\"" <> attr <> "\": \"" <> str <> "\"}")
