module Feature.Generation.HTTP ( routes ) where

import           Core.Templates               (renderIndex)
import           Core.Types

import           Feature.Generation.Passwords (gibberish, oldschool,
                                               suggestedScheme, xkcd)
import           Feature.Generation.Templates (renderGen)

import qualified Data.Text                    as T
import qualified Data.Text.Lazy               as LT

import           Control.Monad.Reader         (ask, lift, liftIO)
import           Data.Maybe                   (listToMaybe)
import           Prelude
import           Web.Scotty.Trans

routes :: PurrApp ()
routes = do

  get "/gen" $ do
    genXkcd      <- liftIO $ xkcd
    genOldschool <- liftIO $ oldschool
    genGibberish <- liftIO $ gibberish 18
    html $ renderGen genXkcd genOldschool genGibberish
