module Feature.Generation.Links ( genLink ) where

import           Core.Types
import           Feature.Generation.Shared (rChar, rIndex, validChars)

import           Control.Monad.Reader      (ask, lift)
import           Data.List                 (singleton)

-- Generates a string containing romly generated and capitalized
-- characters. The number of characters used is defined in the global config.dhall.
genLink :: Int -> IO GenLink
genLink linkLength = genLink' linkLength (return "")
  where
    genLink' 0 cs = GenLink' <$> cs
    genLink' d cs = genLink' (d - 1) (cs <> (singleton <$> rChar))
